#include "bconvert.h"
#include <strings.h>
#include <ctype.h>

char authors[10000];
char year[5], month[4], journal[L], title[512], id[40], number[40], alphapage[40];
int  day, volume, fpage, lpage;
char line[MAXLINE];

static char mankeys[10][25];
static int nman = 0;
static int verbose = 0;

main(argc, argv)
int argc; char *argv[];
{
  FILE *ifile,*ofile;
  char tmpname[L],bibname[L];
  int i, j, noptions = 0;

  get_bibdir(tmpname);
  strcat(tmpname,"/keywords");
  open_kw(tmpname);

  ifile = stdin; ofile = stdout;
  for (i = 1; i < argc && argv[i][0] == '-'; i++) {
     for (j = 1; argv[i][j] != '\0'; j++) {
       if (argv[i][j] == 'v') verbose = 1;
       else if (argv[i][j] == 'k') {strcpy(mankeys[nman++],argv[++i]); break;}
       else {fprintf(stderr,"No such option: %c\n",argv[i][j]);exit(0);}
     }
  }
  noptions = i - 1;

  for (i = 1 + noptions; i < argc; i++) {
    ifile = fopen(argv[i],"r");
    if (ifile == NULL) {
      fprintf(stderr,"No such file: %s\n",argv[i]);
      continue;
    }else{
      sprintf(tmpname,"%s.tmp",argv[i]);
      sprintf(bibname,"%s.bib",argv[i]);
      ofile = fopen(tmpname,"w");
    }

    medline(ifile,ofile);

    system3("bsed",tmpname,bibname);
    system2("rm",tmpname);
  }
  exit(0);
}

int checkpage(char page[])
{
  char tmppage[40];
  int c,i,j=0,k=0,m;

  //the alpha-part  
  for (i=0; (c = page[i]) != '\0'; i++) {
    if (isalpha(c)) {
      alphapage[i]=c;
      j++;
    }
    else {
      alphapage[i]='\0';
      break;
    }
  }
  if(c=='\0')
    alphapage[j]='\0';
    
  k=m=j;
  //first-page, stupid phys rev
  for (i=j; (c = page[i]) != '\0'; i++) {
    if (isdigit(c)) {
      tmppage[i-m]=c;
      j++;
    }
    else {
      tmppage[i-m]='\0';
      break;
    }
  }
  if(c=='\0')
    tmppage[j-m]='\0';

  if(tmppage[0]=='0') {
    for (i=0; (c = tmppage[i]) != '\0'; i++)
      alphapage[k++]=c;
    alphapage[k]='\0';
    fpage=0;
    lpage=0;
    return 0;
  }
  else if(tmppage[0]!='\0')
    fpage=atoi(tmppage);

  while((c = page[j]) != '\0') {
    if(isdigit(c))
      break;
    else
      j++;
  }

  m=j;
  //last-page
  for (i=j; (c = page[i]) != '\0'; i++) {
    if (isdigit(c)) {
      tmppage[i-m]=c;
      j++;
    }
    else {
      tmppage[i-m]='\0';
      break;
    }
  }
  if(c=='\0')
    tmppage[j-m]='\0';

  if(tmppage[0]!='\0') {
    lpage=atoi(tmppage);
  }
  return 0;
}

int redo_pp(fp,lp)
int fp,lp;
{
  int j=1;
  while (j <= lp) j *= 10;
  while ((lp += j) < fp);
  return lp;
}

int is_von(name)
char name[];
{
  int von = 0;
  if (name[0] == 'D' && name[2] == ' ') von = 1;
  else if (name[0] == 'H' && name[1] == 'e' && name[2] == 't' && name[3] == ' ') von = 1;
  else if (name[0] == 'I' && name[1] == 'n' && name[2] == ' ') von = 1;
  else if (name[0] == 'L' && name[1] == 'e' && name[2] == ' ') von = 1;
  else if (name[0] == 'L' && name[1] == 'a' && name[2] == ' ') von = 1;
  else if (name[0] == 'V' && name[2] == 'n' && name[3] == ' ') von = 1;   
  else if (name[0] == 'D' && name[1] == 'e' && name[3] == ' ') von = 1;
  else if (name[0] == 'T' && name[1] == 'e' && name[3] == ' ') von = 1;
  return von;
}

int dot_journal(line)
char line[];
{
  int i,j,dot;

  for (dot=i=0; line[i] != '\0'; i++)
    if (line[i] == '.') dot = 1;
  if (dot) strcpy(journal,line);
  else {
    for (i=j=0; line[i] != '\0'; i++) {
      if (line[i] == ' ' && journal[j-1] != '.') journal[j++] = '.';
      journal[j++] = line[i];
    }
    journal[j++] = '.';
    journal[j++] = '\0';
  }
}

int write_entry(f)
FILE *f;
{
  int i,j,caps,space=0;
  char fauthor[L],abbrev[5];

  for (i=j=0; authors[i] != ','; i++){
    if (authors[i]=='\{' && (authors[i+1]=='\\') &&
    (authors[i+2]=='u') && (authors[i+3]=='p'))
      {i+=12;fauthor[j++] = toupper(authors[i]);i+=2;} 
          /* Checking for {\uppercase */
    else if (isalpha(authors[i])) fauthor[j++] = authors[i];}
  fauthor[j] = '\0';

  abbrev[0] = tolower(journal[0]);
  for (i=j=1; j < 4 && journal[i] != '\0'; i++)
  if (journal[i] == ' ' && isalpha(journal[i+1]))
    abbrev[j++] = tolower(journal[i+1]);
  abbrev[j] = '\0';

  fprintf(f,"@ARTICLE{%s.%s%c%c,\n",
    fauthor,abbrev,year[2],year[3]);
  if (verbose) fprintf(stderr,"%s.%s%c%c (%s)\n",
    fauthor,abbrev,year[2],year[3],id);
  fprintf(f,"AUTHOR = {%s},\n",authors);
  if (isupper(title[1])) { caps = 1; fprintf(f,"TITLE = {{");}
  else { caps = 0; fprintf(f,"TITLE = {");}
  for (i=0; title[i] != '\0'; i++) {
    if (!space && !isalpha(title[i]) && !isdigit(title[i])) space = 1;
    if (space && !caps && isupper(title[i])) {
      fprintf(f,"{%c",title[i]); caps = 1;
    }
    else if (caps && !isalpha(title[i]) && !isdigit(title[i])) {
      fprintf(f,"}%c", title[i]); caps = 0;
    }
    else fprintf(f,"%c",title[i]);
  }
  if (caps) fprintf(f,"}},\n");
  else fprintf(f,"},\n");
  fprintf(f,"JOURNAL = {%s},\n",journal);
  fprintf(f,"VOLUME = {%d},\n",volume);
  if (fpage == 0)
    fprintf(f,"PAGES = {%s},\n",alphapage);
  else if (fpage == lpage) fprintf(f,"PAGES = {%s%d},\n",alphapage,fpage); 
  else fprintf(f,"PAGES = {%s%d--%s%d},\n",alphapage,fpage,alphapage,lpage);
  fprintf(f,"YEAR = {%s},\n",year);
  if (strcmp(month," ") != 0) fprintf(f,"MONTH = %s,\n",month);
  if (strcmp(number," ") != 0) fprintf(f,"NUMBER = {%s},\n",number);
  if (strcmp(id," ") != 0) fprintf(f,"MEDLINE = {%s},\n",id);
  fprintf(f,"KEYWORDS = {");
  for (i=0; i < nman && i < 10; i++)
    fprintf(f,"%s ",mankeys[i]);
  report_kw(f,verbose);
  fprintf(f,"}\n}\n\n");

  if (verbose) fprintf(stderr,"\n");
}
