#include <stdio.h>
#include <strings.h>
#include <ctype.h>

#define L 100
#define TAB 6

char line[81];

FILE *file_open();

main(argc, argv)
int argc; char *argv[];
{
  int i;

  if (argc < 2) {
    fprintf(stderr,"Supply filename(s)\n");
    exit(1);
  }
  for (i = 1; i < argc; i++)
    if (check_file(argv[i])) split_file(argv[i]);
}

int check_file(filename)
char filename[];
{
  int c,i;
  int seenat = 0, nlines = 0, nrefs = 0, stack = 0, error = 0;
  FILE *ifile;
  
  ifile = file_open(filename,"r",0);
  if (ifile == NULL) return 0;

  while ((c = getc(ifile)) != EOF && !error) {
    if (c == '{') stack++;
    if (c == '}') stack--;
    if (c == '\n') nlines++;
    if (c == '@') {
      nrefs++;
      if (stack != 0) error = 1;
      seenat = 1;
    }
  }
  if (stack != 0) error = 1;
  fclose(ifile);

  if (!seenat) {
    fprintf(stderr,"This is not a bibtex file: %s\n",filename);
    return 0;
  }
  if (error) {
    fprintf(stderr,"Brackets don't balance: line %d, ref %d\n",nlines,nrefs);
    fprintf(stderr,"Please check %s\n",filename);
    return 0;
  } else return 1;
}

int split_file(filename)
char filename[];
{
  FILE *ifile,*ofile;
  char entryname[L], key[20];
  int c, i, stack;
  ifile = fopen(filename,"r");
  ofile = NULL;

  while ((c = getc(ifile)) != EOF) {
    if (c == '@') {
      line[0] = c;
      for (i=1; (c = getc(ifile)) != '\n' && c != EOF && i < 80;
i++)
        line[i] = c;
      line[i] = '\0';
      if (c == EOF || i >= 80) 
        fprintf(stderr,"Something wrong:\n%s\n",line);
      sscanf(line,"%s",&key);
      for (i=0; line[i] != '{'; i++);
      stack = 1;
      sscanf(&line[i+1],"%s",&entryname);
      for (i=0; entryname[i] != ',' && entryname[i] != '\0'; i++);
      entryname[i] = '\0';
      ofile = fopen(entryname,"w");
      fprintf(ofile,"%s",line);
    }

    if (ofile != NULL) putc(c,ofile);

    if (c == '{') stack++;

    if (c == '}') {
      stack--;
      if (stack == 0) {
        putc('\n',ofile);
        putc('\n',ofile);
        fclose(ofile);
        file_install(entryname);
      }
    }

  }
  fclose(ifile);
  return 1;
}

int file_install(filename)
char filename[];
{
  char fullname[L], genname[L];
  int i,j,stop;
  get_bibdir(fullname);
  strcpy(fullname,"$BIBDIR/Files/");
  strcat(fullname,filename);
  strcpy(genname,fullname);
  for (i=0; genname[i] != '\0'; i++);
  if (!file_exists(genname)) {
    genname[i] = 'a';
    genname[i+1] = '\0';
    if (!file_exists(genname)) {
      system3("mv ",filename,fullname);
      return 0;
    }
  }
  if (file_same(fullname,filename)) { 
    system2("rm ",filename);
    return 0;
  }
  
  for (j='a'; j <= 'z'; j++) {
    genname[i] = j;
    genname[i+1] = '\0';
    if (!file_exists(genname))
      break;
    else if (file_same(genname,filename)) {
      system2("rm ",filename);
      return 0;
    }
  }
  
  strcpy(fullname,"$BIBDIR/Conflicts/");
  strcat(fullname,filename);
  if (file_exists(fullname)) {
    for (i=0; fullname[i] != '\0'; i++);
    fullname[i+1] = '\0';
    for (stop=0, j='a'; j <= 'z' && !stop; j++) {
      fullname[i] = j;
      if (!file_exists(fullname)) stop = 1;
    }
  }
  system3("mv ",filename,fullname);
  fprintf(stderr,"Conflict! Moved to: %s\n",fullname);
}

