#include "bconvert.h"
#include <strings.h>
#include <ctype.h>

int TAB=6;
int format = MEDLINE;

extern char authors[10000];
extern char year[5], month[4], journal[L], title[512], id[40], number[40];
extern int  day, volume, fpage, lpage;
extern char line[MAXLINE];

static int first_author;
static char page[40];

void finish(FILE *ofile)
{
  checkpage(page);
  if (lpage == 0) lpage = fpage;
  if (lpage < fpage) lpage = redo_pp(fpage,lpage);  
  write_entry(ofile);
  day = volume = fpage = lpage = 0;
  first_author = 1;  
  strcpy(id," ");
  strcpy(month," ");
  strcpy(number," ");
}

static void proc_medline(ofile,line)
FILE *ofile;
char line[];
{
  char key[4];
  char name[L],initials[10];
  int lastc,c,i,j,pagepos;
  int comma, junior, lsp, csp;
  int leftbracket, rightbracket, colon, semicolon, year_pos;
  
  key[0] = line[0]; key[1] = line[1]; key[2] = line[2]; key[3] = '\0';
  if ('\0' == key[2]) key[2] = ' ';

  if (DEBUG) fprintf(stderr, "%s\n%s\n",key,line);

  if (strcmp(key,"FN ") == 0) {
    format = ISI;
    TAB = 3; 
  }
  else if (strcmp(key,"Pro") == 0) {
    format = NATURE;
    TAB = 6; 
  }
  else if (strcmp(key,"UI ") == 0 || strcmp(key,"PMI") == 0) {
    format = MEDLINE;
    TAB = 6;
    sscanf(&line[TAB],"%s",id);  
  }
  else if (strcmp(key,"DP ") == 0)
    sscanf(&line[TAB],"%s%s%d",year,month,&day);
  else if (strcmp(key,"IP ") == 0)
    sscanf(&line[TAB],"%s",number);
  else if (strcmp(key,"SP ") == 0 || strcmp(key,"BP ") == 0)
    sscanf(&line[TAB],"%s",page);
  else if (strcmp(key,"EP ") == 0) {
    pagepos=0;
    while(page[pagepos]!='\0')
      pagepos++;
    page[pagepos++]='-';
    sscanf(&line[TAB],"%s",&page[pagepos]);
  }
  else if (strcmp(key,"PG ") == 0 && format!=ISI) {
    sscanf(&line[TAB],"%s",page);
  }
  else if  (strcmp(key,"VI ") == 0 || strcmp(key,"VL ") == 0) 
    sscanf(&line[TAB],"%d",&volume);
  else if  (strcmp(key,"AU ") == 0) {
    /* first get rid of . and , because in some formats they are
       missing anyway */
    comma = lsp = csp = 0;
    lastc = ' ';
    for (i=j=0; (c = line[TAB+j]) != '\0'; j++) {
      if (',' == c && 0 == comma) comma = i;
      if (c != '.' && c != ',' && !(c == ' ' && lastc == '.')) 
	line[i++] = c;
      else
	lastc = c;
    }
    line[i] = '\0';
    if (DEBUG) printf("%s\n",line);
    if (strcmp(&line[0],"et al") == 0)
      strcat(authors,"AND others");
    else {
      strcpy(name,line);
      name[0] = toupper(name[0]);

      for (j=0; (c = name[j]) != '\0'; j++) {
	if (c == ' ') {csp = lsp; lsp = j;}
      }
      if ( (junior = !strcmp(&name[lsp]," Jr")) ) {
	name[lsp] = '\0';
	lsp = csp;
      }
      if (comma) lsp = comma;
      if (lsp) {
	name[lsp] = '\0';
	i = 0;
	for (j=1; name[lsp+j] != '\0'; j++) 
	  if (isupper(c=name[lsp+j]))
	    initials[i++] = name[lsp+j]; 
	initials[i] = '\0';
      }
      else
	initials[0] = '\0';
      
      /*   if (is_von(name)) {  
	   c = tolower(name[0]);
	   while (lsp) {name[(lsp+12)]=name[lsp]; lsp--;}
	   strncpy(name,"\\uppercase{ }",13);  
	   name[11] = c;
	   } */
      if (DEBUG) printf("%s\n%s\n",name,initials);
      if (first_author) {
	strcpy(authors,name);
	first_author = 0;
      }else{
	strcat(authors,"AND ");
	strcat(authors,name);
      }   
      if (junior) strcat(authors,", Jr, ");
      else strcat(authors,", ");
      
      for (i=j=0; initials[j] != '\0'; j++) {
	name[i++] = initials[j];
	if (initials[j]!='-') name[i++] = '.';
	if ((initials[j]!='-') && (initials[j+1]!='-')) name[i++] = ' ';
      }
      name[i++] = '\0';
      strcat(authors,name);
    }
  }
  else if (strcmp(key,"TA ") == 0 || strcmp(key,"JO ") == 0 || strcmp(key,"JI ") == 0)
    dot_journal(&line[TAB]);
 
  else if (strcmp(key,"PY ") == 0) {
    for (i=TAB; line[i] != '\0'; i++)
      if (!isdigit(line[i])) line[i] = ' ';
    sscanf(&line[TAB],"%s %s",&year,&month);
  }
  else if (strcmp(key,"TI ") == 0) {
    strcpy(title,&line[TAB]);
    check_kw(title);
  }
  else if  (strcmp(key,"MH ") == 0)
    check_kw(&line[TAB]);
  else if  (strcmp(key,"AB ") == 0)
    check_kw(&line[TAB]);
  else if  (strcmp(key,"ER ") == 0)
    finish(ofile);
  else if  (strcmp(key,"SO ") == 0) {
    if (volume == 0 && MEDLINE == format) {
      leftbracket = colon = semicolon = year_pos = 0;
      for (j=TAB; (c = line[j]) != '\0'; j++) {
        if (leftbracket && c == ':') colon = j;
        else if (semicolon && c == '(') leftbracket = j;
        else if (semicolon && c == ')') rightbracket = j;
        else if (year_pos && c == ';') semicolon = j;
        else if (!year_pos && isdigit(line[j]) && isdigit(line[j+1]) 
          && isdigit(line[j+2]) && isdigit(line[j+3])) year_pos = j;
      }
      line[year_pos-1] = line[semicolon] = line[leftbracket] = line[rightbracket] = '\0';
      dot_journal(&line[TAB]);
      sscanf(&line[year_pos],"%s%s%d",year,month,&day);
      sscanf(&line[semicolon+1],"%d",&volume);
      sscanf(&line[leftbracket+1],"%s",number);
      sscanf(&line[colon+1],"%s",page);
    }    
    if (MEDLINE == format)
      finish(ofile);
  }
}

void medline(ifile,ofile)
FILE *ifile,*ofile;
{
  int c,i=0;

  first_author = 1;
  strcpy(id," ");
  strcpy(month," ");
  strcpy(number," ");

  while ((c = getc(ifile)) != EOF) {
    if (c != '\n') {
      if (c != '\r') line[i++] = c;
      if (i > MAXLINE) {fprintf(stderr,"Line too long\n"); exit(1);}
    } 
    else {
      c = getc(ifile);
      if (c == ' ' && !('A'==line[0] && 'U'==line[1])) {
	line[i++] = c;
        while ((c = getc(ifile)) == ' ');
        if (c != '\n' && c != '\r' && c != EOF) line[i++] = c;
        else fprintf(stderr,"Unexpected character: %c\n",c);
      } 
      else {
        line[i] = '\0';
        if (i >= 2) proc_medline(ofile,line);
        if (c == '\n') i = 0;
        else {
	  line[0] = c; i = 1;
	  if(' '==line[0]) {
	    line[0]='A';
	    line[1]='U';
	    c = getc(ifile);
	    i=2;
	  }
	}
      }
    }
  }
  fclose(ifile);
  fclose(ofile);
}

